package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.helper.model.EmptyRequest;
import com.iconplus.smartproc.model.request.DrpApprovalRequest;
import com.iconplus.smartproc.model.response.DrpApprovalResponse;
import com.iconplus.smartproc.model.response.GetListUserApprovalResponse;
import com.iconplus.smartproc.service.approval.GetListUserDirekturKomiteService;
import com.iconplus.smartproc.service.approval.GetListUserVpService;
import com.iconplus.smartproc.service.approval.PostCreateDrpApprovalService;
import org.springframework.web.bind.annotation.*;

@CrossOrigin(origins = "${fe.server}", allowCredentials = "true")
@RestController
@RequestMapping("/api/drp/approval")
public class ApprovalDrpController {

    private GetListUserVpService getListUserVpService;
    private GetListUserDirekturKomiteService getListUserDirekturKomiteService;
    private PostCreateDrpApprovalService postCreateDrpApprovalService;
    public ApprovalDrpController(GetListUserVpService getListUserVpService,
                                 GetListUserDirekturKomiteService getListUserDirekturKomiteService,
                                 PostCreateDrpApprovalService postCreateDrpApprovalService) {
        this.getListUserVpService = getListUserVpService;
        this.getListUserDirekturKomiteService = getListUserDirekturKomiteService;
        this.postCreateDrpApprovalService = postCreateDrpApprovalService;
    }

    @GetMapping("/vp")
    public GetListUserApprovalResponse getUserVp(EmptyRequest emptyRequest) {
        return getListUserVpService.execute(emptyRequest);
    }

    @GetMapping("direktur-komite")
    public GetListUserApprovalResponse getUserDirekturKomite(EmptyRequest emptyRequest) {
        return getListUserDirekturKomiteService.execute(emptyRequest);
    }

    @PostMapping
    public DrpApprovalResponse createDrpApproval(@RequestBody DrpApprovalRequest drpApprovalRequest) {
        return postCreateDrpApprovalService.execute(drpApprovalRequest);
    }
}
